Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 2669)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 2718)
@@ -1175,44 +1175,52 @@
 
 kw = "graphicatt";
-usage = "To change default graphic options \n  Usage: graphicatt att_list \n";
+usage = "To change default graphic options\n  Usage: graphicatt att_list\n";
 usage += "att_list=def back to default values, Example: gratt 'red circlemarker5'";
-usage += "\n ------------------ Graphic attribute list ------------------ \n";
-usage += ">> Colors: defcol black white grey red blue green yellow \n";
-usage += "           magenta cyan turquoise navyblue orange siennared purple \n";
-usage += "           limegreen gold violet violetred blueviolet darkviolet \n";
-usage += ">> Lines:  defline normalline thinline thickline dashedline thindashedline \n";
-usage += "           thickdashedline dottedline thindottedline thickdottedline \n";
-usage += ">> Font Att: deffontatt normalfont boldfont italicfont bolditalicfont  \n";
-usage += "             smallfont smallboldfont smallitalicfont smallbolditalicfont \n";
-usage += "             bigfont bigboldfont bigitalicfont bigbolditalicfont \n";
-usage += "             hugefont  hugeboldfont hugeitalicfont hugebolditalicfont \n";
-usage += ">> Font Names: deffont courierfont helveticafont timesfont symbolfont  \n";
-usage += ">> Marker: dotmarker<T>  plusmarker<T>  crossmarker<T> circlemarker<T> \n";
-usage += "           fcirclemarker<T> boxmarker<T> fboxmarker<T> trianglemarker<T> \n";
-usage += "           ftrianglemarker<T>  starmarker<T>  fstarmarker<T> \n";
-usage += "   with <T> = 1 3 5 7 .. 15 , Example fboxmarker5 , plusmarker9 ... \n";
-usage += ">> ArrowMarker: basicarrow<T>  trianglearrow<T>  ftrianglearrow<T> \n";
-usage += "                arrowshapedarrow<T> farrowshapedarrow<T> \n";
-usage += "   with <T> = 5 7 .. 15 , Example trianglearrow7 ... \n";
-usage += ">> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32 \n";
-usage += "                grey128  invgrey128  colrj128  colbr128 \n";
-usage += "                red32cm  green32cm  blue32cm  yellow32cm \n";
-usage += "                orange32cm cyan32cm violet32cm \n";
+usage += "\n ------------------ Graphic attribute list ------------------\n";
+usage += ">> Colors: defcol black white grey red blue green yellow\n";
+usage += "           magenta cyan turquoise navyblue orange siennared purple\n";
+usage += "           limegreen gold violet violetred blueviolet darkviolet\n";
+usage += "   or \"color=name\" \"fgcolor=name\" \"bgcolor=name\" ex: \"color=red\"\n";
+usage += ">> Lines: defline normalline thinline thickline dashedline thindashedline\n";
+usage += "          thickdashedline dottedline thindottedline thickdottedline\n";
+usage += "   or \"line=type,width\"   ex: \"line=dotted,7\"\n";
+usage += ">> Fonts:\n";
+usage += "   > Att: deffontatt normalfont boldfont italicfont bolditalicfont \n";
+usage += "           smallfont smallboldfont smallitalicfont smallbolditalicfont\n";
+usage += "           bigfont bigboldfont bigitalicfont bigbolditalicfont\n";
+usage += "           hugefont  hugeboldfont hugeitalicfont hugebolditalicfont\n";
+usage += "   > Names: deffont courierfont helveticafont timesfont symbolfont \n";
+usage += "   or \"font=name,type,size\"   ex: \"font=courrier,bolditalic,10\"\n";
+usage += ">> Marker: dotmarker<T>  plusmarker<T>  crossmarker<T> circlemarker<T>\n";
+usage += "           fcirclemarker<T> boxmarker<T> fboxmarker<T> trianglemarker<T>\n";
+usage += "           ftrianglemarker<T>  starmarker<T>  fstarmarker<T>\n";
+usage += "       with <T> = 1 3 5 7 .. 15 , Example fboxmarker5 , plusmarker9 ...\n";
+usage += "   or \"marker=type,size\"   ex: \"marker=plus,10\"\n";
+usage += ">> ArrowMarker: basicarrow<T>  trianglearrow<T>  ftrianglearrow<T>\n";
+usage += "                arrowshapedarrow<T> farrowshapedarrow<T>\n";
+usage += "       with <T> = 5 7 .. 15 , Example trianglearrow7 ...\n";
+usage += "   or \"arrow=type,size\"   ex: \"arrow=arrowshaped,10\"\n";
+usage += "------ Specific options for image displays:\n";
+usage += ">> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32\n";
+usage += "                grey128  invgrey128  colrj128  colbr128\n";
+usage += "                red32cm  green32cm  blue32cm  yellow32cm\n";
+usage += "                orange32cm cyan32cm violet32cm\n";
 usage += "                midas_pastel midas_heat midas_rainbow3 midas_bluered\n";
-usage += "                midas_bluewhite midas_redwhite \n";
-usage += "                multicol16 multicol64 \n";
-usage += "   revcmap : This flag reverses ColorMap indexing \n";
-usage += "--- For image displays:    \n";
-usage += ">> ZoomFactors      zoomxN zoomx1 zoomx2 zoomx3 ... \n";
-usage += "                    zoom/N zoom/2 zoom/3 zoom/4 ...\n";
-usage += ">> imagecenter=ix,iy -> Position the image in widget \n";
-usage += ">> lut=ltyp,min,max -> Sets LUT type and min/max for image display \n";
-usage += "                       (ltyp=lin/log/sqrt/square) \n";
-usage += ">> image axes configuration: invx invy exchxy \n";
-usage += ">> Axes / Axe labels / LogScale / xylimits / defdrrect \n";
-usage += "   See setaxesatt command \n";
-usage += ">> stat/nostat or stats/nostats -> Toggle statistic display flag \n";
-usage += ">> title/notitle or tit/notit -> Toggle Auto AddTitle flag \n";
-usage += ">> DisplayWindow: next same win stack inset \n";
+usage += "                midas_bluewhite midas_redwhite\n";
+usage += "                multicol16 multicol64\n";
+usage += ">> revcmap : reverse colorMap\n";
+usage += ">> ZoomFactors :  zoomxN   ex: zoomx1 zoomx2 zoomx3 ...\n";
+usage += "                  zoom/N   ex: zoom/2 zoom/3 zoom/4 ...\n";
+usage += ">> imagecenter=ix,iy : Position the image in widget\n";
+usage += ">> lut=ltyp,min,max : Sets LUT type and min/max\n";
+usage += "                      (ltyp=lin/log/sqrt/square)\n";
+usage += ">> invx,invy,exchxy : image axes configuration\n";
+usage += ">> for Axes / Axe labels / LogScale / xylimits / defdrrect\n";
+usage += "       see setaxesatt command\n";
+usage += "--- General purpose options:\n";
+usage += ">> stat,stats / nsta,nstat,nostat,nostats : Toggle statistic display\n";
+usage += ">> title,tit / notitle,notit -> Toggle automatic title display\n";
+usage += ">> Choose display window: next same win stack inset\n";
+usage += "\n";  
 usage += "   Related commands: setaxesatt setinsetlimits ";  
 mpiac->RegisterCommand(kw, usage, this, grp);
@@ -1221,17 +1229,17 @@
 usage = "To set default axes attributes \n  Usage: setaxesatt att_list \n";
 usage += "Color/Line/Font attributes and axes attributes \n";
-usage += ">> Axes:  axesnone stdaxes=defaxes=boxaxes boxaxesgrid \n";
-usage += "          fineaxes fineaxesgrid centeredaxes finecenteredaxes \n"; 
-usage += "          centeredaxesgrid finecenteredaxesgrid\n"; 
-usage += "          axescenter=x0,y0 (only with centered axes, default \"axescenter=\")\n"; 
-usage += "          grid nogrid labels nolabels  \n"; 
-usage += "          ticks noticks minorticks nominorticks \n"; 
-usage += "          extticks intticks extintticks \n"; 
-usage += "          nbticks=X_NTicks,Y_NTicks  \n"; 
-usage += "          tickslen=MajTickLenFrac,MinTickLenFrac \n"; 
+usage += ">> Axes: axesnone stdaxes=defaxes=boxaxes boxaxesgrid \n";
+usage += "         fineaxes fineaxesgrid centeredaxes finecenteredaxes \n"; 
+usage += "         centeredaxesgrid finecenteredaxesgrid\n"; 
+usage += "         axescenter=x0,y0 (only with centered axes, default \"axescenter=\")\n"; 
+usage += "         grid nogrid labels nolabels  \n"; 
+usage += "         ticks noticks minorticks nominorticks \n"; 
+usage += "         extticks intticks extintticks \n"; 
+usage += "         nbticks=X_NTicks,Y_NTicks  \n"; 
+usage += "         tickslen=MajTickLenFrac,MinTickLenFrac \n"; 
 usage += ">> Axe labels font size: fixedfontsize/autofontsize=fszf \n";
-usage += "          autofontsize=fsizef: Font size computed automatically \n";
-usage += "          fixedfontsize: Use font size attribute (BaseDrawer) \n";
-usage += ">> LogScale : linx liny logx logy -> Lin/Log Scales for 2D plots \n";
+usage += "         autofontsize=fsizef: Font size computed automatically \n";
+usage += "         fixedfontsize: Use font size attribute (BaseDrawer) \n";
+usage += ">> Scale type: linx liny logx logy -> Lin/Log Scales for 2D plots \n";
 usage += ">> xylimits=xmin,xmax,ymin,ymax  -> Forces X-Y limits in 2-D plots \n";
 usage += ">> defdrrect=xmin,xmax,ymin,ymax -> Defines drawing rectangle 2-D plots \n";