Index: trunk/SophyaExt/CodeMinuit/Makefile.old
===================================================================
--- trunk/SophyaExt/CodeMinuit/Makefile.old	(revision 2723)
+++ trunk/SophyaExt/CodeMinuit/Makefile.old	(revision 2723)
@@ -0,0 +1,25 @@
+include $(SOPHYABASEREP)/Include/MakefileUser.h
+
+all:
+	cp MakeMinuit ./code/MakeMinuit
+	cd code; make -f MakeMinuit
+
+clean:
+	cp MakeMinuit ./code/MakeMinuit
+	cd code; make -f MakeMinuit clean
+
+cleanall:
+	cp MakeMinuit ./code/MakeMinuit
+	cd code; make -f MakeMinuit cleanall
+
+install:
+	cp ./code/libminuit.a $(EXTLIBPATH)/.
+	if [ ! -d $(EXTINCPATH)/Cern ] ; then mkdir $(EXTINCPATH)/Cern ; fi
+	cd $(EXTINCPATH)/Cern/.; rm -f cfortran.h minuit.h hbook.h
+	cp ./cfortran/cfortran.h $(EXTINCPATH)/Cern/.
+	cp ./cfortran/minuit.h $(EXTINCPATH)/Cern/.
+	cp ./cfortran/hbook.h $(EXTINCPATH)/Cern/.
+
+test:
+	cp MakeMinuit ./code/MakeMinuit
+	cd code; make -f MakeMinuit test
Index: trunk/SophyaExt/MinuitAdapt/Makefile.old
===================================================================
--- trunk/SophyaExt/MinuitAdapt/Makefile.old	(revision 2723)
+++ trunk/SophyaExt/MinuitAdapt/Makefile.old	(revision 2723)
@@ -0,0 +1,48 @@
+MODULECXXREPNAME :=  MinuitAdapt
+MODULEDECCXXFLAGS := -msg_quiet
+include ../Mgr/Makefile.h
+
+CFLAGS   := $(CFLAGS) -Df2cFortran
+CPPFLAGS := $(CPPFLAGS) -Df2cFortran
+CXXFLAGS := $(CXXFLAGS) -Df2cFortran
+ 
+all: $(LIB)libMinuitAdapt.a
+
+clean: cleantest
+	rm -f $(OBJ)minuitadapt.o $(OBJ)minuitadaptF.o
+	rm -f $(LIB)libMinuitAdapt.a
+
+cleantest:
+	rm -f testminuit testminuit.o
+
+# Doit etre fait automatiquement par mkmflien
+install:
+	cp localmnpout.h minuitprot.h minuitadapt.h $(INC)/.
+
+#----------------------------------------------------------------------
+$(LIB)libMinuitAdapt.a : $(OBJ)minuitadapt.o $(OBJ)minuitadaptF.o
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
+ifeq ($(CXX),cxx)
+	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
+endif 
+ 
+$(OBJ)minuitadaptF.o: minuitadaptF.f
+$(OBJ)minuitadapt.o: minuitadapt.cc minuitadapt.h minuitprot.h
+
+#----------------------------------------------------------------------
+ifdef NOSHLIB
+LIBS = -L$(LIB) -lFitsIOServer -lSamba -lSkyMap -lSkyT -lNTools -lHiStats -lTArray -lSysTools -lm
+ifeq ($(CXX),cxx)
+LIBS := $(LIBS) -lertcxx
+endif
+else
+LIBS = -L$(SLB) -lsophya -lextsophya  -lm
+endif
+LIBMINUIT := -L$(LIB) -lMinuitAdapt -L$(EXTLIBPATH) -lminuit
+LDLIBS := $(LIBS) $(LDLIBS) $(LIBMINUIT) $(LIBFORT)
+
+test: testminuit
+
+testminuit: testminuit.o
+	$(LINK.cc) $^ -o $@ $(LOADLIBES) $(LDLIBS)
+$(OBJ)testminuit.o: testminuit.cc
Index: trunk/SophyaExt/XAstroPack/Makefile.old
===================================================================
--- trunk/SophyaExt/XAstroPack/Makefile.old	(revision 2723)
+++ trunk/SophyaExt/XAstroPack/Makefile.old	(revision 2723)
@@ -0,0 +1,17 @@
+include ../Mgr/Makefile.h
+ 
+all: $(LIB)libXAstroPack.a
+clean:
+	rm -f $(OBJ)mollweide.o $(OBJ)tstxastro.o $(OBJ)xastropack.o $(OBJ)magfield.o
+	rm -f $(LIB)libXAstroPack.a
+$(LIB)libXAstroPack.a : $(OBJ)magfield.o $(OBJ)mollweide.o $(OBJ)xastropack.o
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
+ifeq ($(CXX),cxx)
+	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
+endif 
+ 
+$(OBJ)mollweide.o: mollweide.cc mollweide.h
+$(OBJ)xastropack.o: xastropack.cc xastropack.h \
+ $(INC)machdefs.h \
+ $(EXTINCPATH)XAstro/astro.h
+$(OBJ)magfield.o: magfield.c magfield.h
Index: trunk/SophyaExt/XephemAstroLib/Makefile.old
===================================================================
--- trunk/SophyaExt/XephemAstroLib/Makefile.old	(revision 2723)
+++ trunk/SophyaExt/XephemAstroLib/Makefile.old	(revision 2723)
@@ -0,0 +1,27 @@
+include $(SOPHYABASEREP)/Include/MakefileUser.h
+
+all: libxastro.a
+
+clean:
+	rm -f libxastro.a
+	rm -f *.o testxephem
+
+install:
+	if [ ! -d $(EXTINCPATH)/XAstro ] ; then mkdir $(EXTINCPATH)/XAstro ; fi
+	rm -f $(EXTINCPATH)/XAstro/astro.h
+	rm -f $(EXTINCPATH)/XAstro/bdl.h
+	rm -f $(EXTINCPATH)/XAstro/P_.h
+	rm -f $(EXTLIBPATH)/libxastro.a
+	cp *.h $(EXTINCPATH)/XAstro/.
+	cp libxastro.a $(EXTLIBPATH)/.
+
+OBJASTRO := $(addsuffix .o,$(basename $(wildcard *.c)))
+
+libxastro.a : $(OBJASTRO)
+	$(AR) $(ARFLAGS) $@ $(OBJASTRO)
+
+%.o: %.c
+	$(COMPILE.c) -o $@ $<
+
+testxephem: testxephem.o
+	$(LINK.c) -o $@ $^ -L$(EXTLIBPATH) -lxastro -lc -lm